import { constantRoutes } from '@/router'
import { getRouters } from '@/api/menu'
import { getInfo } from '@/api/login'
import Layout from '@/layout/index'

const permission = {
  state: {
    routes: [],
    addRoutes: []
  },
  mutations: {
    SET_ROUTES: (state, routes) => {
      state.addRoutes = routes
      state.routes = constantRoutes.concat(routes)
    }
  },
  actions: {
    // 生成路由
    GenerateRoutes({ commit }, res) {
      return new Promise(resolve => {
        // 向后端请求路由数据
        // getInfo().then(res => {
        const pathList = res.data.menus.map(item => item.path).join(',').split(',')
        console.log('pathList', pathList)
        if (pathList.includes('nlt_pc')) {
          for (let i = 0, l = res.data.menus.length; i < l; i++) {
            if (res.data.menus[i].path === 'nlt_pc') {
              const accessedRoutes = filterAsyncRouter(res.data.menus[i].children)
              const newRouters = res.data.menus[i].path // 当前用户pc端的菜单权限
              console.log('进来了', accessedRoutes)
              for (let j = 0, l = res.data.menus[i].children.length; j < l; j++) {
                res.data.menus[i].children[j].showFather = 'false'
              }
              if (accessedRoutes[0]) {
                const firstChild = getFirstChild(accessedRoutes[0])
                console.log('firstChild', firstChild)
                accessedRoutes.push({ path: '*', redirect: '/404', hidden: true })
                accessedRoutes.push({ path: '/', redirect: firstChild, hidden: true })
                console.log('accessedRoutes', accessedRoutes)
                commit('SET_ROUTES', accessedRoutes)
              }
              const routers = { accessedRoutes: accessedRoutes, getRouters: newRouters }
              resolve(routers)
            }
          }
        } else {
          const routers = { accessedRoutes: [], getRouters: [] }
          resolve(routers)
        }
        // })
      })
    }
  }
}

// 遍历后台传来的路由字符串，转换为组件对象
function filterAsyncRouter(asyncRouterMap) {
  return asyncRouterMap.filter(route => {
    if (route.component) {
      // Layout组件特殊处理
      if (route.component === 'Layout') {
        route.component = Layout
      } else {
        route.component = loadView(route.component)
      }
    }
    if (route.children != null && route.children && route.children.length) {
      route.children = filterAsyncRouter(route.children)
    }
    return true
  })
}
function getFirstChild(item) {
  if (item.children && item.children.length > 0) {
    return getFirstChild(item.children[0])
  } else {
    return item.path
  }
}

export const loadView = (view) => { // 路由懒加载
  return (resolve) => require([`@/views/${view}`], resolve)
}

export default permission
